(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('primeng/components/common/messageservice'), require('@angular/router'), require('lodash'), require('@angular/common/http')) :
    typeof define === 'function' && define.amd ? define('error-types', ['exports', '@angular/core', 'primeng/components/common/messageservice', '@angular/router', 'lodash', '@angular/common/http'], factory) :
    (global = global || self, factory(global['error-types'] = {}, global.ng.core, global.messageservice, global.ng.router, global.lodash, global.ng.common.http));
}(this, function (exports, core, messageservice, router, lodash, http) { 'use strict';

    var __read = (this && this.__read) || function (o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    };
    var __spread = (this && this.__spread) || function () {
        for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
        return ar;
    };
    var ErrorHandlerService = /** @class */ (function () {
        function ErrorHandlerService(messageService) {
            this.messageService = messageService;
            this._console = console;
        }
        /**
         * @param {?} error
         * @return {?}
         */
        ErrorHandlerService.prototype.handleError = /**
         * @param {?} error
         * @return {?}
         */
        function (error) {
            /** @type {?} */
            var errorLogger = this.getErrorLogger(error);
            /** @type {?} */
            var original = this.getOriginalError(error);
            /** @type {?} */
            var context = this.getDebugContext(error);
            /** @type {?} */
            var message = (original || error).message || "" + error;
            errorLogger(this._console, 'ERROR', message);
            if (original) {
                errorLogger(this._console, 'ORIGINAL ERROR', original);
            }
            if (context) {
                errorLogger(this._console, 'CONTEXT', context);
            }
            this.messageService.add({
                severity: 'error',
                summary: (original || error).constructor.name,
                detail: message,
                life: 15,
                closable: true,
                data: error,
            });
        };
        /**
         * @private
         * @param {?=} error
         * @return {?}
         */
        ErrorHandlerService.prototype.getDebugContext = /**
         * @private
         * @param {?=} error
         * @return {?}
         */
        function (error) {
            return error ? ((/** @type {?} */ (error))).ngDebugContext || this.getDebugContext(this.getOriginalError(error)) : null;
        };
        /**
         * @private
         * @param {?} error
         * @return {?}
         */
        ErrorHandlerService.prototype.getOriginalError = /**
         * @private
         * @param {?} error
         * @return {?}
         */
        function (error) {
            /** @type {?} */
            var original = error;
            while (original) {
                original = ((/** @type {?} */ (original))).ngOriginalError;
            }
            return original;
        };
        /**
         * @private
         * @param {?} error
         * @return {?}
         */
        ErrorHandlerService.prototype.getErrorLogger = /**
         * @private
         * @param {?} error
         * @return {?}
         */
        function (error) {
            return ((/** @type {?} */ (error))).ngErrorLogger || this.defaultErrorLogger;
        };
        /**
         * @private
         * @param {?} console
         * @param {...?} values
         * @return {?}
         */
        ErrorHandlerService.prototype.defaultErrorLogger = /**
         * @private
         * @param {?} console
         * @param {...?} values
         * @return {?}
         */
        function (console) {
            var values = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                values[_i - 1] = arguments[_i];
            }
            console.error.apply(console, __spread(values));
        };
        ErrorHandlerService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        ErrorHandlerService.ctorParameters = function () { return [
            { type: messageservice.MessageService }
        ]; };
        return ErrorHandlerService;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        ErrorHandlerService.prototype._console;
        /**
         * @type {?}
         * @private
         */
        ErrorHandlerService.prototype.messageService;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var GenericErrorComponent = /** @class */ (function () {
        function GenericErrorComponent() {
        }
        GenericErrorComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'lib-generic-error',
                        template: "<div class=\"card ui-message ui-messages-error\">\n  <h1>\n    <i class=\"ui-messages-icon fa fa-exclamation-triangle\"></i>\n    <span i18n class=\"ui-messages-summary\">Erreur !</span>\n  </h1>\n  <p i18n class=\"ui-messages-detail\">Une erreur s'est produite !</p>\n</div>\n"
                    }] }
        ];
        return GenericErrorComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NotFoundErrorComponent = /** @class */ (function () {
        function NotFoundErrorComponent() {
        }
        NotFoundErrorComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'lib-not-found-error',
                        template: "<div class=\"card ui-message ui-messages-error\">\n  <h1>\n    <i class=\"ui-messages-icon fa fa-exclamation-triangle\"></i>\n    <span i18n class=\"ui-messages-summary\">Page non trouv\u00E9e !</span>\n  </h1>\n  <p i18n class=\"ui-messages-detail\">La ressource n'a pas \u00E9t\u00E9 trouv\u00E9e.</p>\n</div>\n"
                    }] }
        ];
        return NotFoundErrorComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var routes = [
        {
            path: 'error/404',
            pathMatch: 'full',
            component: NotFoundErrorComponent,
        },
        { path: 'error/**', component: GenericErrorComponent },
    ];
    var ErrorModule = /** @class */ (function () {
        function ErrorModule() {
        }
        ErrorModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [router.RouterModule.forChild(routes)],
                        exports: [router.RouterModule],
                        providers: [{ provide: core.ErrorHandler, useClass: ErrorHandlerService }],
                        declarations: [GenericErrorComponent, NotFoundErrorComponent],
                    },] }
        ];
        return ErrorModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} that
     * @return {?}
     */
    function isErrorMessageHandler(that) {
        return lodash.hasIn(that, 'setError') && lodash.isFunction(that.setError);
    }
    /**
     * @param {?} that
     * @return {?}
     */
    function isConstraintViolationHandler(that) {
        return lodash.hasIn(that, 'setConstraintViolations') && lodash.isFunction(that.setConstraintViolations);
    }
    /**
     * @param {?} that
     * @return {?}
     */
    function isValidationErrorHandler(that) {
        return lodash.hasIn(that, 'setErrors') && lodash.isFunction(that.setErrors);
    }
    /**
     * @param {?} that
     * @return {?}
     */
    function isErrorLogger(that) {
        return lodash.hasIn(that, 'logError') && lodash.isFunction(that.logError);
    }
    /**
     * @param {?} that
     * @return {?}
     */
    function isErrorHandler(that) {
        return (isErrorMessageHandler(that) ||
            isConstraintViolationHandler(that) ||
            isValidationErrorHandler(that) ||
            isErrorLogger(that));
    }
    /**
     * @param {?} that
     * @return {?}
     */
    function isErrorClearer(that) {
        return lodash.hasIn(that, 'clearErrors') && lodash.isFunction(that.clearErrors);
    }
    /**
     * @param {?} that
     * @return {?}
     */
    function isDispatchableError(that) {
        return lodash.hasIn(that, 'dispatch') && lodash.isFunction(that.dispatch);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Erreur "enveloppant" une autre erreur.
     * @template T
     */
    var   /**
     * Erreur "enveloppant" une autre erreur.
     * @template T
     */
    AppError = /** @class */ (function () {
        function AppError(original, message, stack, transient) {
            if (transient === void 0) { transient = false; }
            this.original = original;
            this.message = message;
            this.stack = stack;
            this.transient = transient;
            this.isNullError = false;
        }
        Object.defineProperty(AppError.prototype, "name", {
            get: /**
             * @return {?}
             */
            function () {
                return this.getName();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} handler
         * @return {?}
         */
        AppError.prototype.dispatch = /**
         * @param {?} handler
         * @return {?}
         */
        function (handler) {
            return ((isErrorLogger(handler) && handler.logError(this.message, this.name, this.stack)) ||
                (isErrorMessageHandler(handler) && handler.setError(this.message)) ||
                (isValidationErrorHandler(handler) && handler.setErrors({ message: this.message })));
        };
        /**
         * @protected
         * @return {?}
         */
        AppError.prototype.getName = /**
         * @protected
         * @return {?}
         */
        function () {
            return (this.original instanceof Error && this.original.name) || this.constructor.name;
        };
        return AppError;
    }());
    if (false) {
        /** @type {?} */
        AppError.prototype.isNullError;
        /** @type {?} */
        AppError.prototype.original;
        /** @type {?} */
        AppError.prototype.message;
        /** @type {?} */
        AppError.prototype.stack;
        /** @type {?} */
        AppError.prototype.transient;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Supprime les erreurs d'un handler.
     * @param {?} handler
     * @return {?}
     */
    function clearErrors(handler) {
        if (isErrorClearer(handler) && handler.clearErrors()) {
            return true;
        }
        /** @type {?} */
        var handled = false;
        if (isErrorMessageHandler(handler) && handler.setError(null)) {
            handled = true;
        }
        if (isValidationErrorHandler(handler) && handler.setErrors(null)) {
            handled = true;
        }
        if (isConstraintViolationHandler(handler) && handler.setConstraintViolations(null)) {
            handled = true;
        }
        return handled;
    }

    var __extends = (this && this.__extends) || (function () {
        var extendStatics = function (d, b) {
            extendStatics = Object.setPrototypeOf ||
                ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
                function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
            return extendStatics(d, b);
        };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    /**
     * Erreur basée sur une réponse HTTP d'erreur.
     */
    var   /**
     * Erreur basée sur une réponse HTTP d'erreur.
     */
    HTTPError = /** @class */ (function (_super) {
        __extends(HTTPError, _super);
        function HTTPError(original, message) {
            return _super.call(this, original, message || original.message || original.statusText, undefined, original.status >= 500) || this;
        }
        Object.defineProperty(HTTPError.prototype, "status", {
            get: /**
             * @return {?}
             */
            function () {
                return this.original.status;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(HTTPError.prototype, "statusText", {
            get: /**
             * @return {?}
             */
            function () {
                return this.original.statusText;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(HTTPError.prototype, "headers", {
            get: /**
             * @return {?}
             */
            function () {
                return this.original.headers;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(HTTPError.prototype, "url", {
            get: /**
             * @return {?}
             */
            function () {
                return this.original.url;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(HTTPError.prototype, "error", {
            get: /**
             * @return {?}
             */
            function () {
                return this.original.error;
            },
            enumerable: true,
            configurable: true
        });
        return HTTPError;
    }(AppError));
    /**
     * Erreur 403: Forbidden
     */
    var   /**
     * Erreur 403: Forbidden
     */
    AccessDeniedError = /** @class */ (function (_super) {
        __extends(AccessDeniedError, _super);
        function AccessDeniedError() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return AccessDeniedError;
    }(HTTPError));
    /**
     * Erreur 401: Authentication Required
     */
    var   /**
     * Erreur 401: Authentication Required
     */
    AuthenticationError = /** @class */ (function (_super) {
        __extends(AuthenticationError, _super);
        function AuthenticationError() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return AuthenticationError;
    }(HTTPError));
    /**
     * Erreur 400: Bad Request
     */
    var   /**
     * Erreur 400: Bad Request
     */
    BadRequestError = /** @class */ (function (_super) {
        __extends(BadRequestError, _super);
        function BadRequestError() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return BadRequestError;
    }(HTTPError));

    var __extends$1 = (this && this.__extends) || (function () {
        var extendStatics = function (d, b) {
            extendStatics = Object.setPrototypeOf ||
                ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
                function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
            return extendStatics(d, b);
        };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    /**
     * Erreur de validation retournée par api-platform.
     */
    var   /**
     * Erreur de validation retournée par api-platform.
     */
    ConstraintViolations = /** @class */ (function (_super) {
        __extends$1(ConstraintViolations, _super);
        function ConstraintViolations(original, message, violations) {
            var _this = _super.call(this, original, message) || this;
            _this.violations = violations;
            return _this;
        }
        /**
         * @param {?} handler
         * @return {?}
         */
        ConstraintViolations.prototype.dispatch = /**
         * @param {?} handler
         * @return {?}
         */
        function (handler) {
            return ((isConstraintViolationHandler(handler) && handler.setConstraintViolations(this.violations)) ||
                _super.prototype.dispatch.call(this, handler));
        };
        /**
         * @param {?} violations
         * @return {?}
         */
        ConstraintViolations.create = /**
         * @param {?} violations
         * @return {?}
         */
        function (violations) {
            return new ConstraintViolations(new http.HttpErrorResponse({
                status: 400,
                statusText: 'Constraint violations',
            }), 'Constraint violations', violations);
        };
        return ConstraintViolations;
    }(BadRequestError));
    if (false) {
        /** @type {?} */
        ConstraintViolations.prototype.violations;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Rapport d'erreur de validation
     * @record
     */
    function ConstraintViolation() { }
    if (false) {
        /** @type {?} */
        ConstraintViolation.prototype.propertyPath;
        /** @type {?} */
        ConstraintViolation.prototype.message;
    }
    /**
     * Types de gestionnaires d'erreurs.
     * @record
     */
    function ErrorMessageHandler() { }
    if (false) {
        /**
         * @param {?} message
         * @return {?}
         */
        ErrorMessageHandler.prototype.setError = function (message) { };
    }
    /**
     * @record
     */
    function ConstraintViolationHandler() { }
    if (false) {
        /**
         * @param {?} violations
         * @return {?}
         */
        ConstraintViolationHandler.prototype.setConstraintViolations = function (violations) { };
    }
    /**
     * @record
     */
    function ValidationErrorHandler() { }
    if (false) {
        /**
         * @param {?} errors
         * @return {?}
         */
        ValidationErrorHandler.prototype.setErrors = function (errors) { };
    }
    /**
     * @record
     */
    function ErrorLogger() { }
    if (false) {
        /**
         * @param {?} message
         * @param {?} name
         * @param {?=} stack
         * @param {?=} context
         * @return {?}
         */
        ErrorLogger.prototype.logError = function (message, name, stack, context) { };
    }
    /**
     * @record
     */
    function ErrorClearer() { }
    if (false) {
        /**
         * @return {?}
         */
        ErrorClearer.prototype.clearErrors = function () { };
    }
    /**
     * @record
     */
    function DispatchableError() { }
    if (false) {
        /** @type {?} */
        DispatchableError.prototype.isNullError;
        /**
         * @param {?} handler
         * @return {?}
         */
        DispatchableError.prototype.dispatch = function (handler) { };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ɵ0 = /**
     * @param {?} handler
     * @return {?}
     */
    function (handler) {
        return clearErrors(handler);
    };
    /**
     * Singleton d'erreur null.
     * @type {?}
     */
    var NullError = {
        isNullError: true,
        name: 'NullError',
        message: 'No error',
        dispatch: (ɵ0),
    };

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Transforme une valeur en erreur.
     *
     * Les informations intéressantes d'HttpErrorResponse et Error sont conservés.
     * @param {?} err
     * @return {?}
     */
    function normalizeError(err) {
        if (err instanceof AppError || err === NullError) {
            return err;
        }
        if (err instanceof http.HttpErrorResponse) {
            return normalizeHttpErrorResponse(err);
        }
        if (err instanceof Error) {
            return new AppError(err, err.message, err.stack, false);
        }
        if (lodash.isEmpty(err)) {
            return NullError;
        }
        if (typeof err === 'object') {
            return new AppError(err, extractMessage(err), err.stack, err.transient || false);
        }
        return new AppError(err, extractMessage(err));
    }
    /**
     * @param {?} err
     * @return {?}
     */
    function normalizeHttpErrorResponse(err) {
        /** @type {?} */
        var body = 'error' in err ? err.error : {};
        /** @type {?} */
        var message = extractMessage(body) || extractMessage(err);
        switch (err.status) {
            case 400:
                if (lodash.has(body, 'violations') && lodash.isArray(body.violations)) {
                    return new ConstraintViolations(err, message, body.violations);
                }
                return new BadRequestError(err, message);
            case 401:
                return new AuthenticationError(err, message);
            case 403:
                return new AccessDeniedError(err, message);
            default:
                return new HTTPError(err, message);
        }
    }
    /**
     * @param {?} err
     * @return {?}
     */
    function extractMessage(err) {
        if (!err) {
            return undefined;
        }
        switch (typeof err) {
            case 'object':
                if ('message' in err) {
                    return err.message;
                }
                if ('hydra:description' in err) {
                    return err['hydra:description'];
                }
                if ('hydra:title' in err) {
                    return err['hydra:title'];
                }
                if ('error' in err) {
                    return extractMessage(err.error);
                }
                break;
            case 'string':
            case 'number':
                return "" + err;
        }
        return undefined;
    }

    var __extends$2 = (this && this.__extends) || (function () {
        var extendStatics = function (d, b) {
            extendStatics = Object.setPrototypeOf ||
                ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
                function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
            return extendStatics(d, b);
        };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    /**
     * Erreur émise lorsqu'une exception ne peut pas être dispatchée.
     */
    var   /**
     * Erreur émise lorsqu'une exception ne peut pas être dispatchée.
     */
    UnhandledError = /** @class */ (function (_super) {
        __extends$2(UnhandledError, _super);
        function UnhandledError(original) {
            return _super.call(this, original, "Unhandled error: " + original.message, original.stack, false) || this;
        }
        return UnhandledError;
    }(AppError));

    var __extends$3 = (this && this.__extends) || (function () {
        var extendStatics = function (d, b) {
            extendStatics = Object.setPrototypeOf ||
                ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
                function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
            return extendStatics(d, b);
        };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    var ValidationError = /** @class */ (function (_super) {
        __extends$3(ValidationError, _super);
        function ValidationError(errors) {
            var _this = _super.call(this, errors, errors.message || 'Validation error') || this;
            _this.errors = errors;
            return _this;
        }
        /**
         * @param {?} handler
         * @return {?}
         */
        ValidationError.prototype.dispatch = /**
         * @param {?} handler
         * @return {?}
         */
        function (handler) {
            return (isValidationErrorHandler(handler) && handler.setErrors(this.errors)) || _super.prototype.dispatch.call(this, handler);
        };
        return ValidationError;
    }(AppError));
    if (false) {
        /** @type {?} */
        ValidationError.prototype.errors;
    }

    exports.AccessDeniedError = AccessDeniedError;
    exports.AppError = AppError;
    exports.AuthenticationError = AuthenticationError;
    exports.BadRequestError = BadRequestError;
    exports.ConstraintViolations = ConstraintViolations;
    exports.ErrorHandlerService = ErrorHandlerService;
    exports.ErrorModule = ErrorModule;
    exports.GenericErrorComponent = GenericErrorComponent;
    exports.HTTPError = HTTPError;
    exports.NotFoundErrorComponent = NotFoundErrorComponent;
    exports.NullError = NullError;
    exports.UnhandledError = UnhandledError;
    exports.ValidationError = ValidationError;
    exports.clearErrors = clearErrors;
    exports.isConstraintViolationHandler = isConstraintViolationHandler;
    exports.isDispatchableError = isDispatchableError;
    exports.isErrorClearer = isErrorClearer;
    exports.isErrorHandler = isErrorHandler;
    exports.isErrorLogger = isErrorLogger;
    exports.isErrorMessageHandler = isErrorMessageHandler;
    exports.isValidationErrorHandler = isValidationErrorHandler;
    exports.normalizeError = normalizeError;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=error-types.umd.js.map
