import { HttpErrorResponse, HttpHeaders } from '@angular/common/http';
import { AppError } from './app.error';
/**
 * Erreur basée sur une réponse HTTP d'erreur.
 */
export declare class HTTPError extends AppError<HttpErrorResponse> {
    constructor(original: HttpErrorResponse, message?: string);
    readonly status: number;
    readonly statusText: string;
    readonly headers: HttpHeaders;
    readonly url: string;
    readonly error: string;
}
/**
 * Erreur 403: Forbidden
 */
export declare class AccessDeniedError extends HTTPError {
}
/**
 * Erreur 401: Authentication Required
 */
export declare class AuthenticationError extends HTTPError {
}
/**
 * Erreur 400: Bad Request
 */
export declare class BadRequestError extends HTTPError {
}
